/**
 * Created by raos on 7/12/17.
 */
"use strict";

const {Builder, By, until} = require('selenium-webdriver');
const NEW_BUTTON_ID = 'form-new-button';
const DELETE_BUTTON_ID = 'delete-button';
const CLOSE_BUTTON_ID = 'close-button';
const SAVE_BUTTON_ID = 'save-button';

module.exports.fillFormForSubmit = function fillFormForSubmit(driver) {


    return driver.findElement(By.id('name'))
        .then(
            (input) => input.sendKeys('Berners-Lee')
        )
        .then(
            driver.findElement(By.id('firstname'))
                .then(
                    (input) => input.sendKeys('Tim')
                )
        )
        .then(
            driver.findElement(By.id('nameShort'))
                .then(
                    (input) => input.sendKeys("T.")
                )
        )
        .then(
            driver.findElement(By.id('personTitle-dr'))
                .then(
                    (option) => option.click()
                )
        )
        .then(
            driver.findElement(By.id('gender-male'))
                .then(
                    (option) => option.click()
                )
        )
        .then(
            driver.findElement(By.id('link-tab-person2'))
                .then(
                    (link) => link.click()
                )
        )
        .then(
            driver.switchTo().frame('notes-editor_ifr')
                .then(
                    driver.findElement(By.id('tinymce'))
                        .then(
                            (editor) => editor.sendKeys('Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse eu orci diam. Phasellus lobortis, ante.')
                        )
                ).then(
                driver.switchTo().defaultContent()
            )
        );
};

module.exports.assertButtonsUnmodifiedForm = function assertButtonsUnmodifiedForm(driver) {
    return driver.findElement(By.id(SAVE_BUTTON_ID))
        .then(
            (button) => driver.wait(until.elementIsDisabled(button))
        )
        .then(
            () => driver.findElement(By.id(CLOSE_BUTTON_ID))
                .then(
                    (button) => driver.wait(until.elementIsEnabled(button))
                )
        )
        .then(
            () => driver.findElement(By.id(DELETE_BUTTON_ID))
                .then(
                    (button) => driver.wait(until.elementIsEnabled(button))
                )
        )
        .then(
            () => driver.findElement(By.id(NEW_BUTTON_ID))
                .then(
                    (button) => driver.wait(until.elementIsEnabled(button))
                )
        )
};

module.exports.saveForm = function saveForm(driver) {
    return driver.findElement(By.id(SAVE_BUTTON_ID))
        .then(
            (button) => button.click()
        )
};